/******************************************/
/**                                      **/
/**          SMS_CB Portable File        **/
/**                                      **/
/**          (C) James McKay 1996        **/
/**                                      **/
/**    This software may not be used     **/
/**    for commercial reasons, the code  **/
/**    may not be modified or reused     **/
/**    without permission.               **/
/**                                      **/
/******************************************/

#define CB_OBJ

#include "sms_end.c"
#include "sms_def.c"
#include "sms_cb.h"

signed char CBdis;

void rlc_b(void) {ACT_RLC(bc.B.h);}
void rlc_c(void) {ACT_RLC(bc.B.l);}
void rlc_d(void) {ACT_RLC(de.B.h);}
void rlc_e(void) {ACT_RLC(de.B.l);}
void rlc_h(void) {ACT_RLC(hl.B.h);}
void rlc_l(void) {ACT_RLC(hl.B.l);}
/*
void rlc_ix(void)
{
	register UC btemp;

	speekb(btemp,(word)(ix.W+CBdis));
	af.B.l=rlcr_f[btemp];
	spokeb((word)(ix.W+CBdis),CALC_RLC(btemp));
	t_add(23);
}

void rlc_iy(void)
{
	register UC btemp;

	speekb(btemp,(word)(iy.W+CBdis));
	af.B.l=rlcr_f[btemp];
	spokeb((word)(iy.W+CBdis),CALC_RLC(btemp));
	t_add(23);
}

void rlc_hl(void)
{
	register UC btemp;

	speekb(btemp,hl.W);
	af.B.l=rlcr_f[btemp];
	spokeb(hl.W,CALC_RLC(btemp));
	t_add(15);
}
*/

void rlc_ix(void)
{
	register UC btemp;

	speekb(btemp,(word)(ix.W+CBdis));
	ACT_RLC(btemp);
	spokeb((word)(ix.W+CBdis),btemp);
	t_add(23);
}

void rlc_iy(void)
{
	register UC btemp;

	speekb(btemp,(word)(iy.W+CBdis));
	ACT_RLC(btemp);
	spokeb((word)(iy.W+CBdis),btemp);
	t_add(23);
}

void rlc_hl(void)
{
	register UC btemp;

	speekb(btemp,hl.W);
	ACT_RLC(btemp);
	spokeb(hl.W,btemp);
	t_add(15);
}


void rlc_a(void) {ACT_RLC(af.B.h);}

void rrc_b(void) {ACT_RRC(bc.B.h);}
void rrc_c(void) {ACT_RRC(bc.B.l);}
void rrc_d(void) {ACT_RRC(de.B.h);}
void rrc_e(void) {ACT_RRC(de.B.l);}
void rrc_h(void) {ACT_RRC(hl.B.h);}
void rrc_l(void) {ACT_RRC(hl.B.l);}
/*
void rrc_ix(void)
{
	register UC btemp;

	speekb(btemp,(word)(ix.W+CBdis));
	af.B.l=rrcr_f[btemp];
	spokeb((word)(ix.W+CBdis),CALC_RRC(btemp));
	t_add(23);
}

void rrc_iy(void)
{
	register UC btemp;

	speekb(btemp,(word)(iy.W+CBdis));
	af.B.l=rrcr_f[btemp];
	spokeb((word)(iy.W+CBdis),CALC_RRC(btemp));
	t_add(23);
}

void rrc_hl(void)
{
	register UC btemp;

	speekb(btemp,hl.W);
	af.B.l=rrcr_f[btemp];
	spokeb(hl.W,CALC_RRC(btemp));
	t_add(15);
}
*/

void rrc_ix(void)
{
	register UC btemp;

	speekb(btemp,(word)(ix.W+CBdis));
	ACT_RRC(btemp);
	spokeb((word)(ix.W+CBdis),btemp);
	t_add(23);
}

void rrc_iy(void)
{
	register UC btemp;

	speekb(btemp,(word)(iy.W+CBdis));
	ACT_RRC(btemp);
	spokeb((word)(iy.W+CBdis),btemp);
	t_add(23);
}

void rrc_hl(void)
{
	register UC btemp;

	speekb(btemp,hl.W);
	ACT_RRC(btemp);
	spokeb(hl.W,btemp);
	t_add(15);
}

void rrc_a(void) {ACT_RRC(af.B.h);}

void rl_b(void) {ACT_RL(bc.B.h);}
void rl_c(void) {ACT_RL(bc.B.l);}
void rl_d(void) {ACT_RL(de.B.h);}
void rl_e(void) {ACT_RL(de.B.l);}
void rl_h(void) {ACT_RL(hl.B.h);}
void rl_l(void) {ACT_RL(hl.B.l);}
/*
void rl_ix(void)
{
	register UC btemp;

	if(!(af.B.l&1))
	{
		speekb(btemp,(word)(ix.W+CBdis));
		spokeb((word)(ix.W+CBdis),CALC_RL0(btemp));
		af.B.l=rlr_f0[btemp];
	}
	else
	{
		speekb(btemp,(word)(ix.W+CBdis));
		spokeb((word)(ix.W+CBdis),CALC_RL1(btemp));
		af.B.l=rlr_f1[btemp];
	}
	t_add(23);
}

void rl_iy(void)
{
	register UC btemp;

	if(!(af.B.l&1))
	{
		speekb(btemp,(word)(iy.W+CBdis));
		spokeb((word)(iy.W+CBdis),CALC_RL0(btemp));
		af.B.l=rlr_f0[btemp];
	}
	else
	{
		speekb(btemp,(word)(iy.W+CBdis));
		spokeb((word)(iy.W+CBdis),CALC_RL1(btemp));
		af.B.l=rlr_f1[btemp];
	}
	t_add(23);
}

void rl_hl(void)
{
	register UC btemp;

	if(!(af.B.l&1))
	{
		speekb(btemp,hl.W);
		spokeb(hl.W,CALC_RL0(btemp));
		af.B.l=rlr_f0[btemp];
	}
	else
	{
		speekb(btemp,hl.W);
		spokeb(hl.W,CALC_RL1(btemp));
		af.B.l=rlr_f1[btemp];
	}
	t_add(15);
}
*/

void rl_ix(void)
{
	register UC btemp;

	speekb(btemp,(word)(ix.W+CBdis));
	ACT_RL(btemp);
	spokeb((word)(ix.W+CBdis),btemp);
	t_add(23);
}

void rl_iy(void)
{
	register UC btemp;

	speekb(btemp,(word)(iy.W+CBdis));
	ACT_RL(btemp);
	spokeb((word)(iy.W+CBdis),btemp);
	t_add(23);
}

void rl_hl(void)
{
	register UC btemp;

	speekb(btemp,hl.W);
	ACT_RL(btemp);
	spokeb(hl.W,btemp);
	t_add(15);
}

void rl_a(void) {ACT_RL(af.B.h);}

void rr_b(void) {ACT_RR(bc.B.h);}
void rr_c(void) {ACT_RR(bc.B.l);}
void rr_d(void) {ACT_RR(de.B.h);}
void rr_e(void) {ACT_RR(de.B.l);}
void rr_h(void) {ACT_RR(hl.B.h);}
void rr_l(void) {ACT_RR(hl.B.l);}
/*
void rr_ix(void)
{
	register UC btemp;

	if(!(af.B.l&1))
	{
		speekb(btemp,(word)(ix.W+CBdis));
		spokeb((word)(ix.W+CBdis),CALC_RR0(btemp));
		af.B.l=rrr_f0[btemp];
	}
	else
	{
		speekb(btemp,(word)(ix.W+CBdis));
		spokeb((word)(ix.W+CBdis),CALC_RR1(btemp));
		af.B.l=rrr_f1[btemp];
	}
	t_add(23);
}

void rr_iy(void)
{
	register UC btemp;

	if(!(af.B.l&1))
	{
		speekb(btemp,(word)(iy.W+CBdis));
		spokeb((word)(iy.W+CBdis),CALC_RR0(btemp));
		af.B.l=rrr_f0[btemp];
	}
	else
	{
		speekb(btemp,(word)(iy.W+CBdis));
		spokeb((word)(iy.W+CBdis),CALC_RR1(btemp));
		af.B.l=rrr_f1[btemp];
	}
	t_add(23);
}

void rr_hl(void)
{
	register UC btemp;

	if(!(af.B.l&1))
	{
		speekb(btemp,hl.W);
		spokeb(hl.W,CALC_RR0(btemp));
		af.B.l=rrr_f0[btemp];
	}
	else
	{
		speekb(btemp,hl.W);
		spokeb(hl.W,CALC_RR1(btemp));
		af.B.l=rrr_f1[btemp];
	}
	t_add(15);
}
*/

void rr_ix(void)
{
	register UC btemp;

	speekb(btemp,(word)(ix.W+CBdis));
	ACT_RR(btemp);
	spokeb((word)(ix.W+CBdis),btemp);
	t_add(23);
}

void rr_iy(void)
{
	register UC btemp;

	speekb(btemp,(word)(iy.W+CBdis));
	ACT_RR(btemp);
	spokeb((word)(iy.W+CBdis),btemp);
	t_add(23);
}

void rr_hl(void)
{
	register UC btemp;

	speekb(btemp,hl.W);
	ACT_RR(btemp);
	spokeb(hl.W,btemp);
	t_add(15);
}

void rr_a(void) {ACT_RR(af.B.h);}

void sla_b(void) {ACT_SLA(bc.B.h);}
void sla_c(void) {ACT_SLA(bc.B.l);}
void sla_d(void) {ACT_SLA(de.B.h);}
void sla_e(void) {ACT_SLA(de.B.l);}
void sla_h(void) {ACT_SLA(hl.B.h);}
void sla_l(void) {ACT_SLA(hl.B.l);}

void sla_ix(void)
{
	register UC btemp;

	speekb(btemp,(word)(ix.W+CBdis));
	spokeb((word)(ix.W+CBdis),CALC_SLA(btemp));
	af.B.l=sla_f[btemp];
	t_add(23);
}

void sla_iy(void)
{
	register UC btemp;

	speekb(btemp,(word)(iy.W+CBdis));
	spokeb((word)(iy.W+CBdis),CALC_SLA(btemp));
	af.B.l=sla_f[btemp];
	t_add(23);
}

void sla_hl(void)
{
	register UC btemp;

	speekb(btemp,hl.W);
	spokeb(hl.W,CALC_SLA(btemp));
	af.B.l=sla_f[btemp];
	t_add(15);
}

void CBsla_a(void) {ACT_SLA(af.B.h);}

void sra_b(void) {ACT_SRA(bc.B.h);}
void sra_c(void) {ACT_SRA(bc.B.l);}
void sra_d(void) {ACT_SRA(de.B.h);}
void sra_e(void) {ACT_SRA(de.B.l);}
void sra_h(void) {ACT_SRA(hl.B.h);}
void sra_l(void) {ACT_SRA(hl.B.l);}

void sra_ix(void)
{
	register UC btemp;

	speekb(btemp,(word)(ix.W+CBdis));
	spokeb((word)(ix.W+CBdis),CALC_SRA(btemp));
	af.B.l=sra_f[btemp];
	t_add(23);
}

void sra_iy(void)
{
	register UC btemp;

	speekb(btemp,(word)(iy.W+CBdis));
	spokeb((word)(iy.W+CBdis),CALC_SRA(btemp));
	af.B.l=sra_f[btemp];
	t_add(23);
}

void sra_hl(void)
{
	register UC btemp;

	speekb(btemp,hl.W);
	spokeb(hl.W,CALC_SRA(btemp));
	af.B.l=sra_f[btemp];
	t_add(15);
}

void CBsra_a(void) {ACT_SRA(af.B.h);}

void sll_b(void) {ACT_SLL(bc.B.h);}
void sll_c(void) {ACT_SLL(bc.B.l);}
void sll_d(void) {ACT_SLL(de.B.h);}
void sll_e(void) {ACT_SLL(de.B.l);}
void sll_h(void) {ACT_SLL(hl.B.h);}
void sll_l(void) {ACT_SLL(hl.B.l);}

void sll_ix(void)
{
	register UC btemp;

	speekb(btemp,(word)(ix.W+CBdis));
	spokeb((word)(ix.W+CBdis),CALC_SLL(btemp));
	af.B.l=sll_f[btemp];
	t_add(23);
}

void sll_iy(void)
{
	register UC btemp;

	speekb(btemp,(word)(iy.W+CBdis));
	spokeb((word)(iy.W+CBdis),CALC_SLL(btemp));
	af.B.l=sll_f[btemp];
	t_add(23);
}

void sll_hl(void)
{
	register UC btemp;

	speekb(btemp,hl.W);
	spokeb(hl.W,CALC_SLL(btemp));
	af.B.l=sll_f[btemp];
	t_add(15);
}

void CBsll_a(void) {ACT_SLL(af.B.h);}

void srl_b(void) {ACT_SRL(bc.B.h);}
void srl_c(void) {ACT_SRL(bc.B.l);}
void srl_d(void) {ACT_SRL(de.B.h);}
void srl_e(void) {ACT_SRL(de.B.l);}
void srl_h(void) {ACT_SRL(hl.B.h);}
void srl_l(void) {ACT_SRL(hl.B.l);}

void srl_ix(void)
{
	register UC btemp;

	speekb(btemp,(word)(ix.W+CBdis));
	spokeb((word)(ix.W+CBdis),CALC_SRL(btemp));
	af.B.l=srl_f[btemp];
	t_add(23);
}

void srl_iy(void)
{
	register UC btemp;

	speekb(btemp,(word)(iy.W+CBdis));
	spokeb((word)(iy.W+CBdis),CALC_SRL(btemp));
	af.B.l=srl_f[btemp];
	t_add(23);
}

void srl_hl(void)
{
	register UC btemp;

	speekb(btemp,hl.W);
	spokeb(hl.W,CALC_SRL(btemp));
	af.B.l=srl_f[btemp];
	t_add(15);
}

void CBsrl_a(void) {ACT_SRL(af.B.h);}
/*
#define bit_reg(reg,orr) \
	af.B.l&=0xBF; \
	if(reg|orr) af.B.l|=0x40; \
	t_add(8);

#define bit_mem(mem,orr,t_s) \
	register UC btemp; \
	af.B.l&=0xBF; \
	speekb(btemp,mem); \
	if(btemp|orr) af.B.l|=0x40; \
	t_add(t_s);

#define bit7_reg(reg,orr) \
	af.B.l&=0x3F; \
	if(reg|orr) af.B.l|=0xC0; \
	t_add(8);

#define bit7_mem(mem,orr,t_s) \
	register UC btemp; \
	af.B.l&=0x3F; \
	speekb(btemp,mem); \
	if(btemp|orr) af.B.l|=0xC0; \
	t_add(t_s);

void bit0_b(void) {bit_reg(bc.B.h,1);}
void bit0_c(void) {bit_reg(bc.B.l,1);}
void bit0_d(void) {bit_reg(de.B.h,1);}
void bit0_e(void) {bit_reg(de.B.l,1);}
void bit0_h(void) {bit_reg(hl.B.h,1);}
void bit0_l(void) {bit_reg(hl.B.l,1);}
void bit0_ix(void) {bit_mem((word)(ix.W+CBdis),1,20);}
void bit0_iy(void) {bit_mem((word)(iy.W+CBdis),1,20);}
void bit0_hl(void) {bit_mem(hl.W,1,12);}
void bit0_a(void) {bit_reg(af.B.h,1);}

void bit1_b(void) {bit_reg(bc.B.h,2);}
void bit1_c(void) {bit_reg(bc.B.l,2);}
void bit1_d(void) {bit_reg(de.B.h,2);}
void bit1_e(void) {bit_reg(de.B.l,2);}
void bit1_h(void) {bit_reg(hl.B.h,2);}
void bit1_l(void) {bit_reg(hl.B.l,2);}
void bit1_ix(void) {bit_mem((word)(ix.W+CBdis),2,20);}
void bit1_iy(void) {bit_mem((word)(iy.W+CBdis),2,20);}
void bit1_hl(void) {bit_mem(hl.W,2,12);}
void bit1_a(void) {bit_reg(af.B.h,2);}

void bit2_b(void) {bit_reg(bc.B.h,4);}
void bit2_c(void) {bit_reg(bc.B.l,4);}
void bit2_d(void) {bit_reg(de.B.h,4);}
void bit2_e(void) {bit_reg(de.B.l,4);}
void bit2_h(void) {bit_reg(hl.B.h,4);}
void bit2_l(void) {bit_reg(hl.B.l,4);}
void bit2_ix(void) {bit_mem((word)(ix.W+CBdis),4,20);}
void bit2_iy(void) {bit_mem((word)(iy.W+CBdis),4,20);}
void bit2_hl(void) {bit_mem(hl.W,4,12);}
void bit2_a(void) {bit_reg(af.B.h,4);}

void bit3_b(void) {bit_reg(bc.B.h,8);}
void bit3_c(void) {bit_reg(bc.B.l,8);}
void bit3_d(void) {bit_reg(de.B.h,8);}
void bit3_e(void) {bit_reg(de.B.l,8);}
void bit3_h(void) {bit_reg(hl.B.h,8);}
void bit3_l(void) {bit_reg(hl.B.l,8);}
void bit3_ix(void) {bit_mem((word)(ix.W+CBdis),8,20);}
void bit3_iy(void) {bit_mem((word)(iy.W+CBdis),8,20);}
void bit3_hl(void) {bit_mem(hl.W,8,12);}
void bit3_a(void) {bit_reg(af.B.h,8);}

void bit4_b(void) {bit_reg(bc.B.h,16);}
void bit4_c(void) {bit_reg(bc.B.l,16);}
void bit4_d(void) {bit_reg(de.B.h,16);}
void bit4_e(void) {bit_reg(de.B.l,16);}
void bit4_h(void) {bit_reg(hl.B.h,16);}
void bit4_l(void) {bit_reg(hl.B.l,16);}
void bit4_ix(void) {bit_mem((word)(ix.W+CBdis),16,20);}
void bit4_iy(void) {bit_mem((word)(iy.W+CBdis),16,20);}
void bit4_hl(void) {bit_mem(hl.W,16,12);}
void bit4_a(void) {bit_reg(af.B.h,16);}

void bit5_b(void) {bit_reg(bc.B.h,32);}
void bit5_c(void) {bit_reg(bc.B.l,32);}
void bit5_d(void) {bit_reg(de.B.h,32);}
void bit5_e(void) {bit_reg(de.B.l,32);}
void bit5_h(void) {bit_reg(hl.B.h,32);}
void bit5_l(void) {bit_reg(hl.B.l,32);}
void bit5_ix(void) {bit_mem((word)(ix.W+CBdis),32,20);}
void bit5_iy(void) {bit_mem((word)(iy.W+CBdis),32,20);}
void bit5_hl(void) {bit_mem(hl.W,32,12);}
void bit5_a(void) {bit_reg(af.B.h,32);}

void bit6_b(void) {bit_reg(bc.B.h,64);}
void bit6_c(void) {bit_reg(bc.B.l,64);}
void bit6_d(void) {bit_reg(de.B.h,64);}
void bit6_e(void) {bit_reg(de.B.l,64);}
void bit6_h(void) {bit_reg(hl.B.h,64);}
void bit6_l(void) {bit_reg(hl.B.l,64);}
void bit6_ix(void) {bit_mem((word)(ix.W+CBdis),64,20);}
void bit6_iy(void) {bit_mem((word)(iy.W+CBdis),64,20);}
void bit6_hl(void) {bit_mem(hl.W,64,12);}
void bit6_a(void) {bit_reg(af.B.h,64);}

void bit7_b(void) {bit7_reg(bc.B.h,128);}
void bit7_c(void) {bit7_reg(bc.B.l,128);}
void bit7_d(void) {bit7_reg(de.B.h,128);}
void bit7_e(void) {bit7_reg(de.B.l,128);}
void bit7_h(void) {bit7_reg(hl.B.h,128);}
void bit7_l(void) {bit7_reg(hl.B.l,128);}
void bit7_ix(void) {bit7_mem((word)(ix.W+CBdis),128,20);}
void bit7_iy(void) {bit7_mem((word)(iy.W+CBdis),128,20);}
void bit7_hl(void) {bit7_mem(hl.W,128,12);}
void bit7_a(void) {bit7_reg(af.B.h,128);}
*/

void bit0_b(void)
{
	af.B.l=bit_f0[bc.B.h]|(af.B.l&1);
	t_add(8);
}

void bit0_c(void)
{
	af.B.l=bit_f0[bc.B.l]|(af.B.l&1);
	t_add(8);
}

void bit0_d(void)
{
	af.B.l=bit_f0[de.B.h]|(af.B.l&1);
	t_add(8);
}

void bit0_e(void)
{
	af.B.l=bit_f0[de.B.l]|(af.B.l&1);
	t_add(8);
}

void bit0_h(void)
{
	af.B.l=bit_f0[hl.B.h]|(af.B.l&1);
	t_add(8);
}

void bit0_l(void)
{
	af.B.l=bit_f0[hl.B.l]|(af.B.l&1);
	t_add(8);
}

void bit0_ix(void)
{
	register UC btemp;

	speekb(btemp,(word)(ix.W+CBdis));
	af.B.l=bit_f0[btemp]|(af.B.l&1);
	t_add(20);
}

void bit0_iy(void)
{
	register UC btemp;

	speekb(btemp,(word)(iy.W+CBdis));
	af.B.l=bit_f0[btemp]|(af.B.l&1);
	t_add(20);
}

void bit0_hl(void)
{
	register UC btemp;

	speekb(btemp,hl.W);
	af.B.l=bit_f0[btemp]|(af.B.l&1);
	t_add(12);
}

void bit0_a(void)
{
	af.B.l=bit_f0[af.B.h]|(af.B.l&1);
	t_add(8);
}

void bit1_b(void)
{
	af.B.l=bit_f1[bc.B.h]|(af.B.l&1);
	t_add(8);
}

void bit1_c(void)
{
	af.B.l=bit_f1[bc.B.l]|(af.B.l&1);
	t_add(8);
}

void bit1_d(void)
{
	af.B.l=bit_f1[de.B.h]|(af.B.l&1);
	t_add(8);
}

void bit1_e(void)
{
	af.B.l=bit_f1[de.B.l]|(af.B.l&1);
	t_add(8);
}

void bit1_h(void)
{
	af.B.l=bit_f1[hl.B.h]|(af.B.l&1);
	t_add(8);
}

void bit1_l(void)
{
	af.B.l=bit_f1[hl.B.l]|(af.B.l&1);
	t_add(8);
}

void bit1_ix(void)
{
	register UC btemp;

	speekb(btemp,(word)(ix.W+CBdis));
	af.B.l=bit_f1[btemp]|(af.B.l&1);
	t_add(20);
}

void bit1_iy(void)
{
	register UC btemp;

	speekb(btemp,(word)(iy.W+CBdis));
	af.B.l=bit_f1[btemp]|(af.B.l&1);
	t_add(20);
}

void bit1_hl(void)
{
	register UC btemp;

	speekb(btemp,hl.W);
	af.B.l=bit_f1[btemp]|(af.B.l&1);
	t_add(12);
}

void bit1_a(void)
{
	af.B.l=bit_f1[af.B.h]|(af.B.l&1);
	t_add(8);
}

void bit2_b(void)
{
	af.B.l=bit_f2[bc.B.h]|(af.B.l&1);
	t_add(8);
}

void bit2_c(void)
{
	af.B.l=bit_f2[bc.B.l]|(af.B.l&1);
	t_add(8);
}

void bit2_d(void)
{
	af.B.l=bit_f2[de.B.h]|(af.B.l&1);
	t_add(8);
}

void bit2_e(void)
{
	af.B.l=bit_f2[de.B.l]|(af.B.l&1);
	t_add(8);
}

void bit2_h(void)
{
	af.B.l=bit_f2[hl.B.h]|(af.B.l&1);
	t_add(8);
}

void bit2_l(void)
{
	af.B.l=bit_f2[hl.B.l]|(af.B.l&1);
	t_add(8);
}

void bit2_ix(void)
{
	register UC btemp;

	speekb(btemp,(word)(ix.W+CBdis));
	af.B.l=bit_f2[btemp]|(af.B.l&1);
	t_add(20);
}

void bit2_iy(void)
{
	register UC btemp;

	speekb(btemp,(word)(iy.W+CBdis));
	af.B.l=bit_f2[btemp]|(af.B.l&1);
	t_add(20);
}

void bit2_hl(void)
{
	register UC btemp;

	speekb(btemp,hl.W);
	af.B.l=bit_f2[btemp]|(af.B.l&1);
	t_add(12);
}

void bit2_a(void)
{
	af.B.l=bit_f2[af.B.h]|(af.B.l&1);
	t_add(8);
}

void bit3_b(void)
{
	af.B.l=bit_f3[bc.B.h]|(af.B.l&1);
	t_add(8);
}

void bit3_c(void)
{
	af.B.l=bit_f3[bc.B.l]|(af.B.l&1);
	t_add(8);
}

void bit3_d(void)
{
	af.B.l=bit_f3[de.B.h]|(af.B.l&1);
	t_add(8);
}

void bit3_e(void)
{
	af.B.l=bit_f3[de.B.l]|(af.B.l&1);
	t_add(8);
}

void bit3_h(void)
{
	af.B.l=bit_f3[hl.B.h]|(af.B.l&1);
	t_add(8);
}

void bit3_l(void)
{
	af.B.l=bit_f3[hl.B.l]|(af.B.l&1);
	t_add(8);
}

void bit3_ix(void)
{
	register UC btemp;

	speekb(btemp,(word)(ix.W+CBdis));
	af.B.l=bit_f3[btemp]|(af.B.l&1);
	t_add(20);
}

void bit3_iy(void)
{
	register UC btemp;

	speekb(btemp,(word)(iy.W+CBdis));
	af.B.l=bit_f3[btemp]|(af.B.l&1);
	t_add(20);
}

void bit3_hl(void)
{
	register UC btemp;

	speekb(btemp,hl.W);
	af.B.l=bit_f3[btemp]|(af.B.l&1);
	t_add(12);
}

void bit3_a(void)
{
	af.B.l=bit_f3[af.B.h]|(af.B.l&1);
	t_add(8);
}

void bit4_b(void)
{
	af.B.l=bit_f4[bc.B.h]|(af.B.l&1);
	t_add(8);
}

void bit4_c(void)
{
	af.B.l=bit_f4[bc.B.l]|(af.B.l&1);
	t_add(8);
}

void bit4_d(void)
{
	af.B.l=bit_f4[de.B.h]|(af.B.l&1);
	t_add(8);
}

void bit4_e(void)
{
	af.B.l=bit_f4[de.B.l]|(af.B.l&1);
	t_add(8);
}

void bit4_h(void)
{
	af.B.l=bit_f4[hl.B.h]|(af.B.l&1);
	t_add(8);
}

void bit4_l(void)
{
	af.B.l=bit_f4[hl.B.l]|(af.B.l&1);
	t_add(8);
}

void bit4_ix(void)
{
	register UC btemp;

	speekb(btemp,(word)(ix.W+CBdis));
	af.B.l=bit_f4[btemp]|(af.B.l&1);
	t_add(20);
}

void bit4_iy(void)
{
	register UC btemp;

	speekb(btemp,(word)(iy.W+CBdis));
	af.B.l=bit_f4[btemp]|(af.B.l&1);
	t_add(20);
}

void bit4_hl(void)
{
	register UC btemp;

	speekb(btemp,hl.W);
	af.B.l=bit_f4[btemp]|(af.B.l&1);
	t_add(12);
}

void bit4_a(void)
{
	af.B.l=bit_f4[af.B.h]|(af.B.l&1);
	t_add(8);
}

void bit5_b(void)
{
	af.B.l=bit_f5[bc.B.h]|(af.B.l&1);
	t_add(8);
}

void bit5_c(void)
{
	af.B.l=bit_f5[bc.B.l]|(af.B.l&1);
	t_add(8);
}

void bit5_d(void)
{
	af.B.l=bit_f5[de.B.h]|(af.B.l&1);
	t_add(8);
}

void bit5_e(void)
{
	af.B.l=bit_f5[de.B.l]|(af.B.l&1);
	t_add(8);
}

void bit5_h(void)
{
	af.B.l=bit_f5[hl.B.h]|(af.B.l&1);
	t_add(8);
}

void bit5_l(void)
{
	af.B.l=bit_f5[hl.B.l]|(af.B.l&1);
	t_add(8);
}

void bit5_ix(void)
{
	register UC btemp;

	speekb(btemp,(word)(ix.W+CBdis));
	af.B.l=bit_f5[btemp]|(af.B.l&1);
	t_add(20);
}

void bit5_iy(void)
{
	register UC btemp;

	speekb(btemp,(word)(iy.W+CBdis));
	af.B.l=bit_f5[btemp]|(af.B.l&1);
	t_add(20);
}

void bit5_hl(void)
{
	register UC btemp;

	speekb(btemp,hl.W);
	af.B.l=bit_f5[btemp]|(af.B.l&1);
	t_add(12);
}

void bit5_a(void)
{
	af.B.l=bit_f5[af.B.h]|(af.B.l&1);
	t_add(8);
}

void bit6_b(void)
{
	af.B.l=bit_f6[bc.B.h]|(af.B.l&1);
	t_add(8);
}

void bit6_c(void)
{
	af.B.l=bit_f6[bc.B.l]|(af.B.l&1);
	t_add(8);
}

void bit6_d(void)
{
	af.B.l=bit_f6[de.B.h]|(af.B.l&1);
	t_add(8);
}

void bit6_e(void)
{
	af.B.l=bit_f6[de.B.l]|(af.B.l&1);
	t_add(8);
}

void bit6_h(void)
{
	af.B.l=bit_f6[hl.B.h]|(af.B.l&1);
	t_add(8);
}

void bit6_l(void)
{
	af.B.l=bit_f6[hl.B.l]|(af.B.l&1);
	t_add(8);
}

void bit6_ix(void)
{
	register UC btemp;

	speekb(btemp,(word)(ix.W+CBdis));
	af.B.l=bit_f6[btemp]|(af.B.l&1);
	t_add(20);
}

void bit6_iy(void)
{
	register UC btemp;

	speekb(btemp,(word)(iy.W+CBdis));
	af.B.l=bit_f6[btemp]|(af.B.l&1);
	t_add(20);
}

void bit6_hl(void)
{
	register UC btemp;

	speekb(btemp,hl.W);
	af.B.l=bit_f6[btemp]|(af.B.l&1);
	t_add(12);
}

void bit6_a(void)
{
	af.B.l=bit_f6[af.B.h]|(af.B.l&1);
	t_add(8);
}

void bit7_b(void)
{
	af.B.l=bit_f7[bc.B.h]|(af.B.l&1);
	t_add(8);
}

void bit7_c(void)
{
	af.B.l=bit_f7[bc.B.l]|(af.B.l&1);
	t_add(8);
}

void bit7_d(void)
{
	af.B.l=bit_f7[de.B.h]|(af.B.l&1);
	t_add(8);
}

void bit7_e(void)
{
	af.B.l=bit_f7[de.B.l]|(af.B.l&1);
	t_add(8);
}

void bit7_h(void)
{
	af.B.l=bit_f7[hl.B.h]|(af.B.l&1);
	t_add(8);
}

void bit7_l(void)
{
	af.B.l=bit_f7[hl.B.l]|(af.B.l&1);
	t_add(8);
}

void bit7_ix(void)
{
	register UC btemp;

	speekb(btemp,(word)(ix.W+CBdis));
	af.B.l=bit_f7[btemp]|(af.B.l&1);
	t_add(20);
}

void bit7_iy(void)
{
	register UC btemp;

	speekb(btemp,(word)(iy.W+CBdis));
	af.B.l=bit_f7[btemp]|(af.B.l&1);
	t_add(20);
}

void bit7_hl(void)
{
	register UC btemp;

	speekb(btemp,hl.W);
	af.B.l=bit_f7[btemp]|(af.B.l&1);
	t_add(12);
}

void bit7_a(void)
{
	af.B.l=bit_f7[af.B.h]|(af.B.l&1);
	t_add(8);
}


#define res_reg(reg,andr) \
	reg&=andr; \
	t_add(8);

#define res_mem(mem,andr,t_s) \
	register UC btemp; \
	speekb(btemp,mem); \
	spokeb(mem,btemp&andr); \
	t_add(t_s);

void res0_b(void) {res_reg(bc.B.h,254);}
void res0_c(void) {res_reg(bc.B.l,254);}
void res0_d(void) {res_reg(de.B.h,254);}
void res0_e(void) {res_reg(de.B.l,254);}
void res0_h(void) {res_reg(hl.B.h,254);}
void res0_l(void) {res_reg(hl.B.l,254);}
void res0_ix(void) {res_mem((word)(ix.W+CBdis),254,23);}
void res0_iy(void) {res_mem((word)(iy.W+CBdis),254,23);}
void res0_hl(void) {res_mem(hl.W,254,15);}
void res0_a(void) {res_reg(af.B.h,254);}

void res1_b(void) {res_reg(bc.B.h,253);}
void res1_c(void) {res_reg(bc.B.l,253);}
void res1_d(void) {res_reg(de.B.h,253);}
void res1_e(void) {res_reg(de.B.l,253);}
void res1_h(void) {res_reg(hl.B.h,253);}
void res1_l(void) {res_reg(hl.B.l,253);}
void res1_ix(void) {res_mem((word)(ix.W+CBdis),253,23);}
void res1_iy(void) {res_mem((word)(iy.W+CBdis),253,23);}
void res1_hl(void) {res_mem(hl.W,253,15);}
void res1_a(void) {res_reg(af.B.h,253);}

void res2_b(void) {res_reg(bc.B.h,251);}
void res2_c(void) {res_reg(bc.B.l,251);}
void res2_d(void) {res_reg(de.B.h,251);}
void res2_e(void) {res_reg(de.B.l,251);}
void res2_h(void) {res_reg(hl.B.h,251);}
void res2_l(void) {res_reg(hl.B.l,251);}
void res2_ix(void) {res_mem((word)(ix.W+CBdis),251,23);}
void res2_iy(void) {res_mem((word)(iy.W+CBdis),251,23);}
void res2_hl(void) {res_mem(hl.W,251,15);}
void res2_a(void) {res_reg(af.B.h,251);}

void res3_b(void) {res_reg(bc.B.h,247);}
void res3_c(void) {res_reg(bc.B.l,247);}
void res3_d(void) {res_reg(de.B.h,247);}
void res3_e(void) {res_reg(de.B.l,247);}
void res3_h(void) {res_reg(hl.B.h,247);}
void res3_l(void) {res_reg(hl.B.l,247);}
void res3_ix(void) {res_mem((word)(ix.W+CBdis),247,23);}
void res3_iy(void) {res_mem((word)(iy.W+CBdis),247,23);}
void res3_hl(void) {res_mem(hl.W,247,15);}
void res3_a(void) {res_reg(af.B.h,247);}

void res4_b(void) {res_reg(bc.B.h,239);}
void res4_c(void) {res_reg(bc.B.l,239);}
void res4_d(void) {res_reg(de.B.h,239);}
void res4_e(void) {res_reg(de.B.l,239);}
void res4_h(void) {res_reg(hl.B.h,239);}
void res4_l(void) {res_reg(hl.B.l,239);}
void res4_ix(void) {res_mem((word)(ix.W+CBdis),239,23);}
void res4_iy(void) {res_mem((word)(iy.W+CBdis),239,23);}
void res4_hl(void) {res_mem(hl.W,239,15);}
void res4_a(void) {res_reg(af.B.h,239);}

void res5_b(void) {res_reg(bc.B.h,223);}
void res5_c(void) {res_reg(bc.B.l,223);}
void res5_d(void) {res_reg(de.B.h,223);}
void res5_e(void) {res_reg(de.B.l,223);}
void res5_h(void) {res_reg(hl.B.h,223);}
void res5_l(void) {res_reg(hl.B.l,223);}
void res5_ix(void) {res_mem((word)(ix.W+CBdis),223,23);}
void res5_iy(void) {res_mem((word)(iy.W+CBdis),223,23);}
void res5_hl(void) {res_mem(hl.W,223,15);}
void res5_a(void) {res_reg(af.B.h,223);}

void res6_b(void) {res_reg(bc.B.h,191);}
void res6_c(void) {res_reg(bc.B.l,191);}
void res6_d(void) {res_reg(de.B.h,191);}
void res6_e(void) {res_reg(de.B.l,191);}
void res6_h(void) {res_reg(hl.B.h,191);}
void res6_l(void) {res_reg(hl.B.l,191);}
void res6_ix(void) {res_mem((word)(ix.W+CBdis),191,23);}
void res6_iy(void) {res_mem((word)(iy.W+CBdis),191,23);}
void res6_hl(void) {res_mem(hl.W,191,15);}
void res6_a(void) {res_reg(af.B.h,191);}

void res7_b(void) {res_reg(bc.B.h,127);}
void res7_c(void) {res_reg(bc.B.l,127);}
void res7_d(void) {res_reg(de.B.h,127);}
void res7_e(void) {res_reg(de.B.l,127);}
void res7_h(void) {res_reg(hl.B.h,127);}
void res7_l(void) {res_reg(hl.B.l,127);}
void res7_ix(void) {res_mem((word)(ix.W+CBdis),127,23);}
void res7_iy(void) {res_mem((word)(iy.W+CBdis),127,23);}
void res7_hl(void) {res_mem(hl.W,127,15);}
void res7_a(void) {res_reg(af.B.h,127);}

#define set_reg(reg,orr) \
	reg|=orr; \
	t_add(8);

#define set_mem(mem,orr,t_s) \
	register UC btemp; \
	speekb(btemp,mem); \
	spokeb(mem,btemp|orr); \
	t_add(t_s);

void set0_b(void) {set_reg(bc.B.h,1);}
void set0_c(void) {set_reg(bc.B.l,1);}
void set0_d(void) {set_reg(de.B.h,1);}
void set0_e(void) {set_reg(de.B.l,1);}
void set0_h(void) {set_reg(hl.B.h,1);}
void set0_l(void) {set_reg(hl.B.l,1);}
void set0_ix(void) {set_mem((word)(ix.W+CBdis),1,23);}
void set0_iy(void) {set_mem((word)(iy.W+CBdis),1,23);}
void set0_hl(void) {set_mem(hl.W,1,15);}
void set0_a(void) {set_reg(af.B.h,1);}

void set1_b(void) {set_reg(bc.B.h,2);}
void set1_c(void) {set_reg(bc.B.l,2);}
void set1_d(void) {set_reg(de.B.h,2);}
void set1_e(void) {set_reg(de.B.l,2);}
void set1_h(void) {set_reg(hl.B.h,2);}
void set1_l(void) {set_reg(hl.B.l,2);}
void set1_ix(void) {set_mem((word)(ix.W+CBdis),2,23);}
void set1_iy(void) {set_mem((word)(iy.W+CBdis),2,23);}
void set1_hl(void) {set_mem(hl.W,2,15);}
void set1_a(void) {set_reg(af.B.h,2);}

void set2_b(void) {set_reg(bc.B.h,4);}
void set2_c(void) {set_reg(bc.B.l,4);}
void set2_d(void) {set_reg(de.B.h,4);}
void set2_e(void) {set_reg(de.B.l,4);}
void set2_h(void) {set_reg(hl.B.h,4);}
void set2_l(void) {set_reg(hl.B.l,4);}
void set2_ix(void) {set_mem((word)(ix.W+CBdis),4,23);}
void set2_iy(void) {set_mem((word)(iy.W+CBdis),4,23);}
void set2_hl(void) {set_mem(hl.W,4,15);}
void set2_a(void) {set_reg(af.B.h,4);}

void set3_b(void) {set_reg(bc.B.h,8);}
void set3_c(void) {set_reg(bc.B.l,8);}
void set3_d(void) {set_reg(de.B.h,8);}
void set3_e(void) {set_reg(de.B.l,8);}
void set3_h(void) {set_reg(hl.B.h,8);}
void set3_l(void) {set_reg(hl.B.l,8);}
void set3_ix(void) {set_mem((word)(ix.W+CBdis),8,23);}
void set3_iy(void) {set_mem((word)(iy.W+CBdis),8,23);}
void set3_hl(void) {set_mem(hl.W,8,15);}
void set3_a(void) {set_reg(af.B.h,8);}

void set4_b(void) {set_reg(bc.B.h,16);}
void set4_c(void) {set_reg(bc.B.l,16);}
void set4_d(void) {set_reg(de.B.h,16);}
void set4_e(void) {set_reg(de.B.l,16);}
void set4_h(void) {set_reg(hl.B.h,16);}
void set4_l(void) {set_reg(hl.B.l,16);}
void set4_ix(void) {set_mem((word)(ix.W+CBdis),16,23);}
void set4_iy(void) {set_mem((word)(iy.W+CBdis),16,23);}
void set4_hl(void) {set_mem(hl.W,16,15);}
void set4_a(void) {set_reg(af.B.h,16);}

void set5_b(void) {set_reg(bc.B.h,32);}
void set5_c(void) {set_reg(bc.B.l,32);}
void set5_d(void) {set_reg(de.B.h,32);}
void set5_e(void) {set_reg(de.B.l,32);}
void set5_h(void) {set_reg(hl.B.h,32);}
void set5_l(void) {set_reg(hl.B.l,32);}
void set5_ix(void) {set_mem((word)(ix.W+CBdis),32,23);}
void set5_iy(void) {set_mem((word)(iy.W+CBdis),32,23);}
void set5_hl(void) {set_mem(hl.W,32,15);}
void set5_a(void) {set_reg(af.B.h,32);}

void set6_b(void) {set_reg(bc.B.h,64);}
void set6_c(void) {set_reg(bc.B.l,64);}
void set6_d(void) {set_reg(de.B.h,64);}
void set6_e(void) {set_reg(de.B.l,64);}
void set6_h(void) {set_reg(hl.B.h,64);}
void set6_l(void) {set_reg(hl.B.l,64);}
void set6_ix(void) {set_mem((word)(ix.W+CBdis),64,23);}
void set6_iy(void) {set_mem((word)(iy.W+CBdis),64,23);}
void set6_hl(void) {set_mem(hl.W,64,15);}
void set6_a(void) {set_reg(af.B.h,64);}

void set7_b(void) {set_reg(bc.B.h,128);}
void set7_c(void) {set_reg(bc.B.l,128);}
void set7_d(void) {set_reg(de.B.h,128);}
void set7_e(void) {set_reg(de.B.l,128);}
void set7_h(void) {set_reg(hl.B.h,128);}
void set7_l(void) {set_reg(hl.B.l,128);}
void set7_ix(void) {set_mem((word)(ix.W+CBdis),128,23);}
void set7_iy(void) {set_mem((word)(iy.W+CBdis),128,23);}
void set7_hl(void) {set_mem(hl.W,128,15);}
void set7_a(void) {set_reg(af.B.h,128);}

