/******************************************/
/**                                      **/
/**          SMS_FSL Portable File       **/
/**                                      **/
/**          (C) James McKay 1996        **/
/**                                      **/
/**    This software may not be used     **/
/**    for commercial reasons, the code  **/
/**    may not be modified or reused     **/
/**    without permission.               **/
/**                                      **/
/******************************************/
#ifdef MSDOS_SYSTEM

#ifndef __BORLANDC__

#include <direct.h>
#define EXTENDED_READDIR

#else
#include <dirent.h>
#endif

#else

#define SEEK_SET 0
#define SEEK_CUR 1
#define SEEK_END 2

#include <dirent.h>
#endif
#include <ctype.h>
#include <sys/stat.h>
#include <sys/types.h>

#define XDIR 1
#define XFILE 2
#define XDRIVE 3

void itoa_temp(char *str_num, UC number); /* In X128_TAP.C */
void wtoa_temp(char *str_word, word number);

UC input_string(UC y_i,char *title); /* Just needs to be done! */

void scr_write_letter(UC x, UC y, UC attr, UC letter)
{
	if(attr==121)
	{
		scr_map_addr[(y<<6)+(x<<1)]=letter-' '+96;
	}
	else
	{
		scr_map_addr[(y<<6)+(x<<1)]=letter-' ';
	}
	scr_map_addr[(y<<6)+(x<<1)+1]=0;
}

void scr_write_string(UC x, UC y, UC attr, char *stringy)
{
	while(stringy[0]!='\0')
	{
		scr_write_letter(x,y,attr,stringy[0]);
		stringy++;
		x++;
		if(x==32) {x=0;y++;}
	}
}

void scr_write_string_limit(UC x, UC y, UC attr, char *stringy, UC size)
{
	while((stringy[0]!='\0')&&(size))
	{
		size--;
		scr_write_letter(x,y,attr,stringy[0]);
		stringy++;
		x++;
		if(x==32) {x=0;y++;}
	}
}

void make_box(UC x1, UC y1, UC x2, UC y2, UC attr)
{
	UC x, y;

	for(x=x1;x<x2;x++)
	{
		for(y=y1;y<y2;y++)
		{
			scr_write_letter(x,y,attr,' ');
		}
	}
}

UC different_extension(char *select_string,char *filename)
{
	char *temp_str;
	word pos;
	UC len_of_ss;

	if(select_string[0]=='\0') return 1;
	pos=strlen(filename);
	len_of_ss=strlen(select_string);
	if(pos>len_of_ss)
	{
		pos-=len_of_ss;
	}
	else
	{
		return 1; /* It couldn't possibly have the extension */
	}
	temp_str=filename;
	temp_str+=pos;
	pos=0;
	while(pos<len_of_ss)
	{
		if(tolower(select_string[pos])!=tolower(temp_str[pos]))
		{
			return 1;
		}
		pos++;
	}
	return 0;
}

int sort_function( const void *a, const void *b)
{
   /*return( strcmp((char *)a,(char *)b) );*/
   int ret_val, pos, len_of_larger;
   char *aa, *bb;

   aa=(char *)a;
   bb=(char *)b;

   len_of_larger=strlen(aa);
   pos=strlen(bb);
   if(pos>len_of_larger) len_of_larger=pos;
   ret_val=pos=0;

   while((!ret_val)&&(pos<len_of_larger))
   {
	ret_val=tolower(aa[pos])-tolower(bb[pos]);
	pos++;
   }
   return ret_val;
}

sign16 get_dir(char *select_string_1, char *select_string_2, char *select_string_3)
{
  DIR *dir;
  struct dirent *ent;
  struct stat stbuf;
  char fullpath[MAXPATH];

	sign16 number_got;
	word pos, x;
	unsigned long useful;
	UC snipped, drv_num;

	int cut_point;

	number_got=snipped=0;
	pos=strlen(the_path);
	pos--;
#ifdef MSDOS_SYSTEM
	if(pos!=2)
	{
		the_path[pos]='\0'; /* Watcom */
		snipped=1;
	}
#else
	if(pos)
	{
		the_path[pos]='\0';
		snipped=1;
	}
#endif
	if ((dir = opendir(the_path)) == NULL)
	{
#ifndef NON_WINDOWS
		printf("Could not open directory\n");
		perror("Error:");
#endif
		return 32767;
	}
	if(snipped)
	{
#ifdef MSDOS_SYSTEM
		strcat(the_path,"\\"); /* Watcom */
#else
		strcat(the_path,"/");
#endif
	}

	while ((ent = readdir(dir)) != NULL)
	{
#ifndef EXTENDED_READDIR
		strcpy(FNAME+(number_got*UNIT_SIZE)+1,ent->d_name);
		number_got++;
#else
		if(ent->d_attr&_A_VOLID) continue;
		strcpy(FNAME+(number_got*UNIT_SIZE)+1,ent->d_name);
		if(ent->d_attr&_A_SUBDIR)
		{
			FNAME[number_got*UNIT_SIZE]=XDIR;
		}
		else
		{
			FNAME[number_got*UNIT_SIZE]=XFILE;
		}
		number_got++;
#endif
	}

	if (closedir(dir) != 0)
	{
#ifndef NON_WINDOWS
		printf("Warning:: Could not close directory\n");
		perror("Error:");
#endif
	}

#ifndef EXTENDED_READDIR
	strcpy(fullpath,the_path);
	cut_point=strlen(fullpath);
	for(pos=0;pos<number_got;pos++)
	{
		useful=pos*UNIT_SIZE;
		fullpath[cut_point]='\0';
		strcat(fullpath,FNAME+useful+1);
		stat((char *)fullpath,&stbuf);
		if((stbuf.st_mode & S_IFMT)==S_IFDIR)
		{
			FNAME[useful]=XDIR;
		}
		else
		{
			FNAME[useful]=XFILE;
		}
	}
#endif
	for(pos=0;pos<number_got;pos++)
	{
		useful=pos*UNIT_SIZE;
		if(FNAME[useful]==XDIR)
		{
			if(!(strcmp(FNAME+useful+1,".")))
			{
				for(x=pos;x<number_got;x++)
				{
					memcpy(FNAME+(x*UNIT_SIZE),FNAME+((x+1)*UNIT_SIZE),UNIT_SIZE);
				}
				number_got--;
				pos--;
			}
		}
		if(FNAME[useful]==XFILE)
		{
			if(different_extension(select_string_1,FNAME+useful+1)
			+different_extension(select_string_2,FNAME+useful+1)
			+different_extension(select_string_3,FNAME+useful+1)==2)
			{
				/* Do nothing */
			}
			else
			{
				/* move above stuff down one */
				for(x=pos;x<number_got;x++)
				{
					memcpy(FNAME+(x*UNIT_SIZE),FNAME+((x+1)*UNIT_SIZE),UNIT_SIZE);
				}
				number_got--;
				pos--;
			}
		}
	}
	qsort((void*)FNAME,number_got,UNIT_SIZE,sort_function);
#ifdef MSDOS_SYSTEM
	for(drv_num=1;drv_num<27;drv_num++)
	{
		if(drives[drv_num][0]!='\0')
		{
			FNAME[number_got*UNIT_SIZE]=XDRIVE;
			strcpy(FNAME+(number_got*UNIT_SIZE)+1,drives[drv_num]);
			number_got++;
		}
	}
#endif
	return number_got;
}

void scr_copy(void)
{
	old_screen=scr_map_addr;
	old_tile=tile_addr;
	old_machine_mode=gg_mode;

	old_vreg128=vreg128;old_vreg129=vreg129;
	old_x_scroll=x_scroll;old_y_scroll=y_scroll;
	old_first_y=*sprite_y;*sprite_y=208;

	vreg128=x_scroll=y_scroll=0;vreg129=64;
	gg_mode=0;

	make_line_table();

	/*tile_addr=VIDEO;*/
	tile_addr=CSET;
	memcpy(BUFFER,pal0,16);
	memcpy(BUFFER+16,pal1,16);
	/*scr_map_addr=VIDEO+8192;
	memset(VIDEO+8192,0,1536);*/
	scr_map_addr=CSET+8192;
	memset(CSET+8192,0,1536);

	*pal0=48;
	*(pal0+1)=63;
	*(pal0+2)=63;
	*(pal0+3)=48;
}

void scr_restore(void)
{
	scr_map_addr=old_screen;
	tile_addr=old_tile;

	vreg128=old_vreg128;vreg129=old_vreg129;
	x_scroll=old_x_scroll;y_scroll=old_y_scroll;
	*sprite_y=old_first_y;

	memcpy(pal0,BUFFER,16);
	memcpy(pal1,BUFFER+16,16);
	gg_mode=old_machine_mode;

	make_line_table();

	memset(SCREEN,0,64000);
}

UC input_clean_string(UC y_i,char *title)
{
	UC x, y;
	word pos, ascii_val;

	scr_copy();
	release_keyboard();

	make_box(0,y_i,32,y_i+13,79);
	scr_write_string(1,y_i+1,79,title);
	scr_write_string(0,y_i+3,79,the_path);
	y=strlen(the_path)/32;
	x=strlen(the_path)-(32*y);
	y+=y_i+3;
	scr_write_letter(x,y,121,' ');
	RePaintScreen();
	while(1)
	{
		ascii_val=fsl_asciiext_key();
		pos=strlen(the_path);
		switch(ascii_val)
		{
			case X128_ESCAPE:
				scr_restore();
				init_keyboard();
				return 1;
			case X128_BACKSPACE: case X128_DELETE:
				if(strlen(the_path)>0)
				{
					pos--;
					the_path[pos]='\0';
					scr_write_letter(x,y,79,' ');
					x--; if(x==255) {x=31;y--;}
					scr_write_letter(x,y,121,' ');
					RePaintScreen();
				}
				break;
			case X128_RETURN:
				scr_restore();
				init_keyboard();
				return 0;
			default:
				if(pos+1<MAXPATH)
				{
					the_path[pos]=(UC)(ascii_val&255);
					scr_write_letter(x,y,79,ascii_val&255);
					x++; if(x==32) {x=0;y++;}
					scr_write_letter(x,y,121,' ');
					RePaintScreen();
				}
				break;
		}
	}
}

void setup_talk_window(void)
{
	UC x;

	release_keyboard();
	scr_copy();
	make_box(0,0,32,24,79);
	for(x=0;x<32;x++)
	{
		scr_write_letter(x,11,79,'-');
		scr_write_letter(x,12,79,'-');
	}
}

void undo_talk_window(void)
{
	scr_restore();
	init_keyboard();
}

void quit_window(void)
{
	release_keyboard();
	scr_copy();

	make_box(0,0,32,24,79);
	scr_write_string(1,7,79,"OTHER PLAYER HAS QUIT EMULATOR");
	scr_write_string(4,9,79,"If using a modem, please");
	scr_write_string(6,10,79,"remember to hang up!");
	scr_write_string(10,12,79,"Press ESCAPE");
	RePaintScreen();
	while(fsl_extend_key()!=X128_ESCAPE);

	scr_restore();
	init_keyboard();
}

#define LR_CHECK \
if((value==12)||(value==13)||(value==14) \
	||(value==15)) done=1;

word calc_speed(void)
{
	word wtemp, time_x;

	if(scr_driver==SMS_SD)
	{
		time_x=time_s_sms;
	}
	else
	{
		if(big_gg)
		{
			time_x=time_s_ggb;
		}
		else
		{
			time_x=time_s_ggs;
		}
	}
	if(frame_skip)
	{
		wtemp=10000/(time_p+(time_x/frame_skip)+slow_down);
	}
	else
	{
		wtemp=10000/(time_p+slow_down);
	}
	return wtemp;
}

void help_scr(void)
{
	UC y, done, old_value, old_y;
	word wtemp;
	static UC value=0;
	char str_num[4], str_word[6];
	int adder;

	release_keyboard();
	scr_copy();

	make_box(2,1,30,22,79);
	old_y=y=3;
	scr_write_string(10,y-2,79,"HELP SCREEN");
	scr_write_string(5,y++,79,"F1 : This screen.");
	scr_write_string(5,y++,79,"F2 : Screen Dump (PCX).");
	scr_write_string(5,y++,79,"F3 : Pro Action Replay.");
	scr_write_string(5,y++,79,"F4 : Joystick Options.");
	scr_write_string(5,y++,79,"F5 : Load New Cart.");
	scr_write_string(5,y++,79,"F6 : Save Snap File.");
	scr_write_string(5,y++,79,"F7 : Load Snap File.");
	scr_write_string(5,y++,79,"F8 : Emulation Options.");
	scr_write_string(5,y++,79,"F10: Quit.");
	scr_write_string(5,y++,79,"F11: Sound Option.");
	scr_write_string(5,y,79,"F12:");
	if(gg_connect)
	{
		scr_write_string(10,y++,79,"Chat Window.");
	}
	else
	{
		scr_write_string(10,y++,79,"N/A.");
	}
	y++;
	scr_write_string(5,y,79,"Alter Screen Skip");
	scr_write_string(23,y,79,"1/");
	itoa_temp(str_num,frame_skip);
	scr_write_string(25,y++,79,str_num);
	scr_write_string(5,y,79,"Alter Slow Down");
	wtoa_temp(str_word,slow_down);
	scr_write_string(22,y++,79,str_word);
	scr_write_string(5,y,79,"GG Screen Size :");
	if(big_gg)
	{
		scr_write_string(22,y++,79,"Large");
	}
	else
	{
		scr_write_string(22,y++,79,"Small");
	}
	scr_write_string(5,y,79,"Keep close to 100% :");
	if(try_100)
	{
		scr_write_string(26,y++,79,"Yes");
	}
	else
	{
		scr_write_string(26,y++,79,"No.");
	}

	if(old_machine_mode)
	{
		scr_driver=GG_SD;
	}
	wtemp=calc_speed();
	scr_driver=SMS_SD;
	scr_write_string(5,y,79,"Percent Speed : ");
	wtoa_temp(str_word,wtemp);
	scr_write_string(21,y,79,str_word);
	scr_write_letter(26,y++,79,'%');

	scr_write_string(5,y+1,79,"PRESS ESCAPE TO RETURN.");
	scr_write_string((32-strlen(version_no))>>1,y+3,79,version_no);
	RePaintScreen();

	done=0;
	old_value=value;
	while(!done)
	{
		scr_write_letter(4,value+old_y,121,'>');
		RePaintScreen();
		switch(fsl_extend_key())
		{
			case X128_ESCAPE:
				done=2;
				break;
			case X128_RETURN:
				adder=0;
				done=1;
				break;
			case X128_UP:
				scr_write_letter(4,value+old_y,79,' ');
				if(--value==255) value=15;
				break;
			case X128_DOWN:
				scr_write_letter(4,value+old_y,79,' ');
				value=(++value)%16;
				break;
			case X128_LEFT:
				adder=-1;
				LR_CHECK;
				break;
			case X128_RIGHT:
				adder=+1;
				LR_CHECK;
				break;
			case X128_PAGE_UP: case X128_KP_MINUS:
				adder=-10;
				LR_CHECK;
				break;
			case X128_PAGE_DOWN: case X128_KP_PLUS:
				adder=+10;
				LR_CHECK;
				break;
			default:
				break;
		}
	}
	if(done==2)
	{
		value=old_value;
		quit=DONT_QUIT; /* Not in main due to below */
	}
	else
	{
		switch(value)
		{
			case 0 : quit=QUIT_HELP;break;
			case 1 : quit=QUIT_SCR_DUMP;ret_to_help=1;break;
			case 2 : quit=QUIT_PAR;ret_to_help=1;break;
			case 3 : quit=QUIT_JOY;ret_to_help=1;break;
			case 4 : quit=QUIT_LOAD;ret_to_help=1;break;
			case 5 : quit=QUIT_SAVE_SNAP;ret_to_help=1;break;
			case 6 : quit=QUIT_LOAD_SNAP;ret_to_help=1;break;
			case 7 : quit=QUIT_EMUL_OPTIONS;ret_to_help=1;break;
			case 8 : quit=QUIT_COMPLETELY;break;
			case 9 : quit=QUIT_SOUND;ret_to_help=1;break;
			case 10:
				quit=QUIT_TALK;
				request_talk=1;
				ret_to_help=1;
				break;
			case 11:
				quit=QUIT_HELP;
				ret_to_help=1;
				break;
			case 12:
				frame_skip+=adder;
				quit=QUIT_HELP;
				break;
			case 13:
				slow_down+=adder;
				quit=QUIT_HELP;
				break;
			case 14:
				big_gg^=1;
				if(try_100)
				{
					if(old_machine_mode)
					{
						scr_driver=GG_SD;
					}
					slow_down=0;
					choose_frame_skip();
					choose_delay();
					scr_driver=SMS_SD;
				}
				quit=QUIT_HELP;
				break;
			case 15:
				try_100^=1;
				quit=QUIT_HELP;
				break;
			default:
				quit=DONT_QUIT;
				break;
		}
	}
	scr_restore();
	init_keyboard();
}

void clear_ar_codes(void)
{
	UC x;

	/* For some reason, the for loop */
	/* below is compiled to run 5 times */
	for(x=0;x<MAX_A_REPLAY;x++)
	{
		if(x==MAX_A_REPLAY) break; /* Damn compiler */
		strcpy(a_replay_str[x],"0000-0000");
		a_replay_address[x]=0;
		a_replay_poke[x]=0;
		a_replay_on[x]=0;
	}
}

UC parse_ar_code(UC slot, char *raw_string)
{
	word temp_address;
	UC temp_poke, x, btemp, value;
	char tstr_with_m[10];

	if(slot>=MAX_A_REPLAY) return 0;
	if(raw_string[4]=='-')
	{
		if(strlen(raw_string)<9) return 0;
		memcpy((char *)tstr_with_m,raw_string,9);
	}
	else
	{
		if(strlen(raw_string)<8) return 0;
		memcpy((char *)tstr_with_m,raw_string,4);
		tstr_with_m[4]='-';
		memcpy((char *)tstr_with_m+5,raw_string+4,4);
	}
	tstr_with_m[9]='\0';

	x=0;
	while(x<9)
	{
		btemp=tstr_with_m[x];
		value=255;
		if((btemp>='0')&&(btemp<='9'))
		{
			value=btemp-'0';
		}
		if((btemp>='A')&&(btemp<='F'))
		{
			value=btemp-('A')+10;
		}
		if((btemp>='a')&&(btemp<='f'))
		{
			value=btemp-('a')+10;
			tstr_with_m[x]=(value-10)+'A';
		}
		if((btemp=='-')&&(x==4))
		{
			value=254;
		}
		if(value==255)
		{
			/* Error */
			return 0;
		}
		switch(x)
		{
			case 0: /* Not known */
				break;
			case 1: /* Not known */
				break;
			case 2:
				temp_address=value<<12;
				break;
			case 3:
				temp_address|=value<<8;
				break;
			case 4: /* Minus sign */
				break;
			case 5:
				temp_address|=value<<4;
				break;
			case 6:
				temp_address|=value;
				break;
			case 7:
				temp_poke=value<<4;
				break;
			case 8:
				temp_poke|=value;
				break;
			default:
				break;
		}
		x++;
	}
	strcpy(a_replay_str[slot],tstr_with_m);
	a_replay_address[slot]=temp_address;
	a_replay_poke[slot]=temp_poke;
	return 1;
}

void pro_action_replay(void)
{
	static UC position=0;
	UC done, x, update;

	release_keyboard();
	scr_copy();
	update=1;
	done=0;
	while(!done)
	{
		if(update)
		{
			make_box(2,3,30,19,79);
			scr_write_string(2,4,79,"PRO ACTION REPLAY (C) DATEL");
			scr_write_string(5,7+MAX_A_REPLAY,79,"PRESS ESCAPE TO RETURN.");
			update=0;
		}
		scr_write_letter(5,position+6,121,'>');
		for(x=0;x<MAX_A_REPLAY;x++)
		{
			scr_write_string(6,x+6,79,a_replay_str[x]);
			if(a_replay_on[x])
			{
				scr_write_string(18,x+6,79,"ON ");
			}
			else
			{
				scr_write_string(18,x+6,79,"OFF");
			}
		}
		RePaintScreen();
		switch(fsl_extend_key())
		{
			case X128_ESCAPE:
				done=1;
				break;
			case X128_UP:
				scr_write_letter(5,position+6,79,' ');
				if(--position==255) position=MAX_A_REPLAY-1;
				break;
			case X128_DOWN:
				scr_write_letter(5,position+6,79,' ');
				position=(++position)%MAX_A_REPLAY;
				break;
			case X128_RETURN:
				scr_restore();
				init_keyboard();

				strcpy(the_path,a_replay_str[position]);
				if(!(input_clean_string(4,"Enter Action Replay Code")))
				{
					if(!(parse_ar_code(position,the_path)))
					{
						release_keyboard();
						scr_copy();
						make_box(2,3,29,19,79);
						scr_write_string(6,8,79,"INVALID P.A.R. CODE!");
						scr_write_string(0,10,79,"Code should contain 8 characters");
						scr_write_string(0,11,79,"of 0-9 and A-F, with an optional");
						scr_write_string(7,12,79,"'-' in the middle.");
						scr_write_string(9,14,79,"PRESS ESCAPE.");
						RePaintScreen();
						while(fsl_extend_key()!=X128_ESCAPE);
						scr_restore();
						init_keyboard();
					}
					else
					{
						a_replay_on[position]=1;
					}
				}
				update=1;

				release_keyboard();
				scr_copy();
				break;
			case X128_LEFT:
			case X128_RIGHT:
				a_replay_on[position]^=1;
				break;
			default:
				break;
		}
	}
	scr_restore();
	init_keyboard();
}

void joystick(void)
{
	static UC position=0;
	UC done;
	char str_num[4];

	release_keyboard();
	scr_copy();
	make_box(2,3,30,19,79);
	scr_write_string(8,4,79,"JOYSTICK OPTIONS");
	scr_write_string(6, 6,79,"4 Button Pad");
	scr_write_string(6, 7,79,"SMS 2P 1 Joystick");
	scr_write_string(6, 8,79,"Swap Buttons");
	scr_write_string(6,10,79,"Joysticks Detected :");
	itoa_temp(str_num,joy_present);
	scr_write_string(27,10,79,str_num);
	scr_write_string(5,12,79,"PRESS ESCAPE TO RETURN.");
	done=0;
	while(!done)
	{
		scr_write_letter(5,position+6,121,'>');
		if(ggpad)
		{
			scr_write_string(19,6,79,"Yes");
		}
		else
		{
			scr_write_string(19,6,79,"No.");
		}
		if(joy1_is_p2)
		{
			scr_write_string(24,7,79,"Yes");
		}
		else
		{
			scr_write_string(24,7,79,"No.");
		}
		if(button_swap)
		{
			scr_write_string(19,8,79,"Yes");
		}
		else
		{
			scr_write_string(19,8,79,"No.");
		}
		RePaintScreen();
		switch(fsl_extend_key())
		{
			case X128_ESCAPE:
				done=1;
				break;
			case X128_UP:
				scr_write_letter(5,position+6,79,' ');
				if(--position==255) position=2;
				break;
			case X128_DOWN:
				scr_write_letter(5,position+6,79,' ');
				position=(++position)%3;
				break;
			case X128_RETURN:
			case X128_LEFT:
			case X128_RIGHT:
				switch(position)
				{
					case 0:
						ggpad^=1;
						break;
					case 1:
						joy1_is_p2^=1;
						break;
					case 2:
						button_swap^=1;
						break;
					default:
						break;
				}
				break;
			default:
				break;
		}
	}
	scr_restore();
	init_keyboard();
}

void show_bar(sign16 page_select)
{
	switch(FNAME[page_select*UNIT_SIZE])
	{
	case XDIR:
		scr_write_string_limit(FSL_WIN_START+3,1,121,FNAME+(page_select*UNIT_SIZE)+1,FNAME_SIZE);
		break;
	default:
		scr_write_string_limit(FSL_WIN_START+2,1,121,FNAME+(page_select*UNIT_SIZE)+1,FNAME_SIZE);
		break;
	}
}

void display_page(sign16 lowest, sign16 highest_found)
{
	UC x,y,spos;

	make_box(FSL_WIN_START,1,FSL_WIN_START+FSL_WIN_WIDTH,23,79);
	spos=1;
	if(lowest)
	{
		scr_write_string(13,0,48,"<MORE>");
	}
	else
	{
		scr_write_string(13,0,48,"<<<>>>");
	}
	if(lowest<highest_found-1)
	{
		scr_write_string(13,23,48,"<MORE>");
	}
	else
	{
		scr_write_string(13,23,48,"<<<>>>");
	}

	while((lowest<highest_found)&&(spos<23))
	{
		x=FSL_WIN_START+2;
		y=spos;
		switch(FNAME[lowest*UNIT_SIZE])
		{
		case XDIR   : /* Directory */
			scr_write_letter(x,y,88,'/');
			scr_write_string_limit(x+1,y,88,FNAME+(lowest*UNIT_SIZE)+1,FNAME_SIZE);
			break;
		case XFILE  : /* File */
			scr_write_string_limit(x,y,79,FNAME+(lowest*UNIT_SIZE)+1,FNAME_SIZE);
			break;
		case XDRIVE : /* Drive */
			scr_write_string_limit(x,y,40,FNAME+(lowest*UNIT_SIZE)+1,FNAME_SIZE);
			break;
		default:
			scr_write_string(x,y,7,"<ERROR>");
			break;
		}
		spos++;
		lowest++;
	}
}

void strip_file(char *stringy)
{
	UC special;
	word pos;

	pos=strlen(stringy);
	pos--;
	special=0;
	if((stringy[pos]=='/')||(stringy[pos]=='\\')) return;
	while((stringy[pos]!='/')&&(stringy[pos]!='\\')&&(!special))
	{
		stringy[pos]='\0';
		pos--;
#ifdef MSDOS_SYSTEM
		if(pos<=2)
		{
			special=1;
			stringy[1]='\0';
			strcat(stringy,":\\");
		}
#else
		if(!pos)
		{
			special=1;
			strcpy(stringy,"/");
		}
#endif
	}
}

void dot_dot(void)
{
	UC special;
	word pos, temp_len;
	char temp_str[MAXPATH];

	pos=strlen(the_path);
	pos--;
	special=0;
	strcpy(temp_str,"");
	if((the_path[pos]=='/')||(the_path[pos]=='\\')) pos--;
	while((the_path[pos]!='/')&&(the_path[pos]!='\\')&&(!special))
	{
		pos--;
		if((the_path[pos]=='/')||(the_path[pos]=='\\'))
		{
			strcpy(temp_str,(char *)the_path+pos+1);
		}
#ifdef MSDOS_SYSTEM
		if(pos<=2)
		{
			special=1;
			the_path[1]='\0';
			strcat(the_path,":\\");
		}
#else
		if(!pos)
		{
			special=1;
			strcpy(the_path,"/");
		}
#endif
	}
	temp_len=strlen(temp_str);
	if((temp_str[temp_len-1]=='/')||(temp_str[temp_len-1]=='\\'))
	{
		temp_str[temp_len-1]='\0';
	}
	strcpy(prev_dir,(char *)temp_str);
	if(!special) the_path[pos+1]='\0';
}

void dir_cat(char *addable)
{
	strcat(the_path,addable);
	strcat(the_path,"/");
}

UC input_string(UC y_i,char *title)
{
	UC x, y;
	word pos, ascii_val;

	scr_copy();
	strip_file(the_path);
	release_keyboard();

	make_box(0,y_i,32,y_i+13,79);
	scr_write_string(1,y_i+1,79,title);
	scr_write_string(0,y_i+3,79,the_path);
	y=strlen(the_path)/32;
	x=strlen(the_path)-(32*y);
	y+=y_i+3;
	scr_write_letter(x,y,121,' ');
	RePaintScreen();
	while(1)
	{
		ascii_val=fsl_asciiext_key();
		pos=strlen(the_path);
		switch(ascii_val)
		{
			case X128_ESCAPE:
				scr_restore();
				init_keyboard();
				return 1;
			case X128_BACKSPACE: case X128_DELETE:
				if(strlen(the_path)>0)
				{
					pos--;
					the_path[pos]='\0';
					scr_write_letter(x,y,79,' ');
					x--; if(x==255) {x=31;y--;}
					scr_write_letter(x,y,121,' ');
					RePaintScreen();
				}
				break;
			case X128_RETURN:
				scr_restore();
				init_keyboard();
				return 0;
			default:
				if(pos+1<MAXPATH)
				{
					the_path[pos]=(UC)(ascii_val&255);
					scr_write_letter(x,y,79,ascii_val&255);
					x++; if(x==32) {x=0;y++;}
					scr_write_letter(x,y,121,' ');
					RePaintScreen();
				}
				break;
		}
	}
}

void mess_up_options(void)
{
	static UC s_type=0;
	UC done, old_y, y, update;
	char str_num[6];

	release_keyboard();
	scr_copy();
	done=quit=0;
	update=1;
	while((!done)&&(!quit))
	{
		if(update)
		{
			make_box(2,3,30,19,79);
			scr_write_string(8,4,79,"MESS UP OPTIONS");
			old_y=y=6;
			scr_write_string(6,y,79,"INT 255 :");
			switch(int_255)
			{
				case 0:
				scr_write_string(16,y++,79,"No Int.   ");
				break;
				case 1:
				scr_write_string(16,y++,79,"Immed.Int.");
				break;
				case 2:
				scr_write_string(16,y++,79,"Delay.Int.");
				break;
				default:break;
			}
			scr_write_string(6,y,79,"Top Line : ");
			wtoa_temp(str_num,TOP_LINE);
			scr_write_string(17,y++,79,str_num);

			scr_write_string(6,y,79,"Vblank : ");
			if(!vblank_optional)
			{
				scr_write_string(15,y++,79,"Always. ");
			}
			else
			{
				scr_write_string(15,y++,79,"Optional");
			}
			y++;
			scr_write_string(6,y++,79,"V0.6 Default");
			scr_write_string(6,y++,79,"V0.5 Default");
			y++;
			scr_write_string(6,y,79,"Language :");
			if(japan)
			{
				scr_write_string(17,y++,79,"Japanese");
			}
			else
			{
				scr_write_string(17,y++,79,"English ");
			}
			scr_write_string(6,y,79,"Line Int Method");
			itoa_temp(str_num,LI_method);
			scr_write_string(22,y++,79,str_num);
			scr_write_string(5,16,79,"PRESS ENTER TO SELECT.");
			scr_write_string(5,18,79,"PRESS ESCAPE TO RETURN.");
			update=0;
		}
		scr_write_letter(5,s_type+old_y,121,'>');
		RePaintScreen();
		switch(fsl_extend_key())
		{
			case X128_ESCAPE:
				quit=1;
				break;
			case X128_RETURN:
				done=1;
				break;
			case X128_UP:
				scr_write_letter(5,s_type+old_y,79,' ');
				if(--s_type==255) s_type=8;
				break;
			case X128_DOWN:
				scr_write_letter(5,s_type+old_y,79,' ');
				s_type=(++s_type)%9;
				break;
			case X128_LEFT:
			case X128_RIGHT:
				switch(s_type)
				{
					case 0:
						int_255=(int_255+1)%3;
						break;
					case 1:
						switch(TOP_LINE)
						{
							case 255:
								TOP_LINE=304;
								break;
							case 304:
								TOP_LINE=255;
								break;
							default:
								TOP_LINE=304;
								break;
						}
						break;
					case 2: vblank_optional^=1;break;
					case 7:
						japan^=1;
						break;
					case 8:
						LI_method^=1;
						break;
					default: break;
				}
				update=1;
				break;
			default:
				break;
		}
		if(done)
		{
			switch(s_type)
			{
				case 4:
					int_255=1;
					TOP_LINE=304;
					vblank_optional=0;
					break;
				case 5:
					int_255=0;
					TOP_LINE=255;
					vblank_optional=0;
					break;
				default:
					break;
			}
			update=1;
			done=0;
		}
	}
	scr_restore();
	init_keyboard();
}

void sound_options(void)
{
	static UC s_type=0;
	UC done, old_y, y, update;

	release_keyboard();
	scr_copy();
	done=quit=0;
	update=1;
	while((!done)&&(!quit))
	{
		if(update)
		{
			make_box(2,3,30,19,79);
			scr_write_string(9,4,79,"SOUND OPTIONS");
			old_y=y=6;
			scr_write_string(6,y,79,"Sound Is ");
			if(!all_sound_on)
			{
				scr_write_string(15,y++,79,"Off.      ");
			}
			else
			{
				if(UseAdlib)
				{
					scr_write_string(15,y++,79,"Adlib.    ");
				}
				else
				{
					scr_write_string(15,y++,79,"PC Speaker");
				}
			}
			if(!PSG_open)
			{
				scr_write_string(6,y++,79,"Create LOG File");
			}
			else
			{
				scr_write_string(6,y++,79,"Close LOG File");
			}
			scr_write_string(6,y,79,"White Noise Is ");
			if(!white_noise)
			{
				scr_write_string(21,y++,79,"Off.");
			}
			else
			{
				scr_write_string(21,y++,79,"On.");
			}
			scr_write_string(5,15,79,"PRESS ENTER TO SELECT.");
			scr_write_string(5,17,79,"PRESS ESCAPE TO RETURN.");
			update=0;
		}
		scr_write_letter(5,s_type+old_y,121,'>');
		RePaintScreen();
		switch(fsl_extend_key())
		{
			case X128_ESCAPE:
				quit=1;
				break;
			case X128_RETURN:
				done=1;
				break;
			case X128_UP:
				scr_write_letter(5,s_type+old_y,79,' ');
				if(--s_type==255) s_type=2;
				break;
			case X128_DOWN:
				scr_write_letter(5,s_type+old_y,79,' ');
				s_type=(++s_type)%3;
				break;
			case X128_LEFT:
			case X128_RIGHT:
				switch(s_type)
				{
					case 0:
						if(!all_sound_on)
						{
							all_sound_on=1;
							UseAdlib=0;
							break;
						}
						if(adlib_present)
						{
							if((all_sound_on)&&(!UseAdlib))
							{
								UseAdlib=1;
								break;
							}
							if(UseAdlib)
							{
								all_sound_on=0;
								UseAdlib=0;
								break;
							}
						}
						all_sound_on^=1;
						break;
					case 2: white_noise^=1;break;
					default: break;
				}
				update=1;
				break;
			default:
				break;
		}
		if(done)
		{
			switch(s_type)
			{
				case 1:
					if(PSG_open)
					{
						fclose(p_handle);
						PSG_open=0;
					}
					else
					{
						scr_restore();
						init_keyboard();
#define LOGGING_INSTEAD
#ifdef LOGGING_INSTEAD
						PSG_open=1;
						save_PSG();
#else
						if(!(input_string(4,"Create PSG File")))
						{
							PSG_open=1;
							save_PSG();
						}
#endif
						release_keyboard();
						scr_copy();
					}
					break;
				default:
					break;
			}
			update=1;
			done=0;
		}
	}
	scr_restore();
	init_keyboard();
}

UC search_prev_dir(UC highest_found)
{
	word x;

	for(x=0;x<highest_found;x++)
	{
		if(!(strcmp(prev_dir,FNAME+(UNIT_SIZE*x)+1)))
		{
			return x;
		}
	}
	return 0;
}

sign16 find_letter(char *search_str,sign16 page_select,
		sign16 highest_found,UC *found)
{
	char other[MAXPATH];
	sign16 old_page_select, x;

	old_page_select=page_select;
	if(strlen(search_str)==1) page_select=0;
	while(page_select<highest_found)
	{
		if(FNAME[page_select*UNIT_SIZE]==XFILE)
		{
			strcpy(other,FNAME+(page_select*UNIT_SIZE)+1);
			for(x=0;x<strlen(other);x++) other[x]=tolower(other[x]);
			if(!(strncmp(search_str,other,strlen(search_str))))
			{
				*found=1;
				return page_select;
			}
		}
		page_select++;
	}
	*found=0;
	return old_page_select;
}

UC test_fsl(char *select_string_1, char *select_string_2, char *select_string_3)
{
	UC x, y, quit, chosen, reread, dotdot_prev;
	UC letter_search, found;
	sign16 highest_found, page_select, temp_index, temp_int;
	sign16 pos, temp_ps;
	char temp_str[MAXPATH], temp_str2[MAXPATH], old_prev_dir[MAXPATH];
	char search_str[MAXPATH];

	word ascii_val;

	dotdot_prev=0;
	if(!(FNAME=(UC *)malloc(FSL_BUFF)))
	{
		return 1; /* Can't Allocate Memory */
	}
	else
	{
	      memset(FNAME,0,FSL_BUFF);
	}
	release_keyboard();
	strcpy(temp_str,the_path);
	temp_index=global_index;

	strip_file(the_path);

	scr_copy();
	scr_write_string(0,0,79,select_string_1);
	scr_write_string(0,1,79,select_string_2);
	scr_write_string(0,2,79,select_string_3);
	quit=chosen=0;
	page_select=global_index;
	reread=2; /* Don't overwrite page_select */
	while((!quit)&&(!chosen))
	{
		if(reread)
		{
			temp_int=get_dir(select_string_1,select_string_2,select_string_3);
			if(temp_int!=32767)
			{
				highest_found=temp_int;
				if(dotdot_prev)
				{
					page_select=search_prev_dir(highest_found);
					reread=2;
				}
			}
			else
			{
				reread=2;
				strcpy(the_path,temp_str2);
				strcpy(prev_dir,old_prev_dir);
			}
			if(reread==1)
			{
				page_select=0;
			}
			reread=0;
		}
		display_page(page_select,highest_found);
		show_bar(page_select);
		RePaintScreen();
		letter_search=0;
		switch(ascii_val=fsl_asciiext_key())
		{
			case X128_UP:
				if(page_select) page_select--;
				break;
			case X128_DOWN:
				if(page_select<highest_found-1)
				{
					page_select++;
				}
				break;
			case X128_LEFT:
				break;
			case X128_RIGHT:
				break;
			case X128_PAGE_UP: case X128_KP_MINUS:
				page_select-=22;
				if(page_select<0) page_select=0;
				break;
			case X128_PAGE_DOWN: case X128_KP_PLUS:
				page_select+=22;
				if(page_select>=highest_found)
				{
					page_select=highest_found-1;
				}
				break;
			case X128_RETURN:
				strcpy(temp_str2,the_path);
				strcpy(old_prev_dir,prev_dir);
				dotdot_prev=0;
				switch(FNAME[page_select*UNIT_SIZE])
				{
				case XDIR   : /* Directory */
					if(!strcmp("..",FNAME+(page_select*UNIT_SIZE)+1))
					{
						dot_dot();
						dotdot_prev=1;
						reread=1;
					}
					else
					{
						if(strcmp(".",FNAME+(page_select*UNIT_SIZE)+1))
						{
							dir_cat(FNAME+(page_select*UNIT_SIZE)+1);
							reread=1;
						}
					}
					break;
				case XFILE  : /* File */
					chosen=1;
					strcat(the_path,FNAME+(page_select*UNIT_SIZE)+1);
					break;
				case XDRIVE : /* Drive */
					strcpy(the_path,FNAME+(page_select*UNIT_SIZE)+1);
					reread=1;
					break;
				default:
					break;
				}
				break;
			case X128_ESCAPE:
				quit=1;
				break;
			case X128_HOME:
				page_select=0;
				break;
			case X128_END:
				page_select=highest_found-1;
				break;
			default:
				/* Find letter */
				pos=strlen(search_str);
				search_str[pos]=tolower(ascii_val&255);
				search_str[pos+1]='\0';
				page_select=find_letter(search_str,page_select,highest_found,&found);
				if(!found)
				{
					letter_search=0; /* Failed */
				}
				else
				{
					letter_search=1;
				}
				break;
		}
		if(!letter_search)
		{
			strcpy(search_str,"");
		}
	}
	scr_restore();
	init_keyboard();
	free(FNAME);
	if(chosen)
	{
		global_index=page_select;
		return 0; /* Success */
	}
	global_index=temp_index;
	strcpy(the_path,temp_str);
	return 1; /* Aborted */
}
